package com.cnbm.packing.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.toolkit.ObjectUtils;
import com.cnbm.admin.base.BaseSupport;
import com.cnbm.admin.base.BaseSupport;
import com.cnbm.common.page.PageData;
import com.cnbm.common.service.impl.CrudServiceImpl;
import com.cnbm.common.utils.ConvertUtils;
import com.cnbm.packing.dto.ChangePackagingBoxHistoryDTO;
import com.cnbm.packing.dto.ChangePackagingBoxHistoryDTO;
import com.cnbm.packing.entity.ChangePackagingBoxHistory;
import com.cnbm.packing.entity.ChangePackagingBoxHistory;
import com.cnbm.packing.entity.WoPowerLevel;
import com.cnbm.packing.mapper.ChangePackagingBoxHistoryMapper;
import com.cnbm.packing.service.ChangePackagingBoxHistoryServiceBiz;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.time.LocalDateTime;
import java.util.Arrays;
import java.util.Map;

/**
 * 包装箱拆合箱历史表
 *
 * @author codeGenerator
 * @since 2023-02-16
 */
@Service
public class ChangePackagingBoxHistoryServiceBizImpl extends CrudServiceImpl<ChangePackagingBoxHistoryMapper, ChangePackagingBoxHistory, ChangePackagingBoxHistoryDTO> implements ChangePackagingBoxHistoryServiceBiz {

    @Autowired
    private BaseSupport baseSupport;

    @Override
    public QueryWrapper<ChangePackagingBoxHistory> getWrapper(Map<String, Object> params){
        LocalDateTime startTime = (LocalDateTime) params.get("startTime");
        LocalDateTime endTime = (LocalDateTime) params.get("endTime");

        QueryWrapper<ChangePackagingBoxHistory> wrapper = new QueryWrapper<>();
        wrapper.between(startTime!=null && endTime!=null,ChangePackagingBoxHistory.INPUT_TIME, startTime, endTime);
        wrapper.between(startTime!=null && endTime!=null,ChangePackagingBoxHistory.LEAVE_TIME, startTime, endTime);
        if(params.get("type")!=null) {
            Integer type = Integer.parseInt( params.get("type").toString());
            wrapper.eq(ObjectUtils.isNotNull(type), ChangePackagingBoxHistory.TYPE, type);
        }

        return wrapper;
    }

    @Override
    public PageData<ChangePackagingBoxHistoryDTO> page (Map<String, Object> params){
        IPage<ChangePackagingBoxHistory> page = baseDao.selectPage(
                getPage(params, ChangePackagingBoxHistory.CREATE_TIME, true),
                getWrapper(params)
        );
        return getPageData(page, ChangePackagingBoxHistoryDTO.class);
    }

    @Override
    public ChangePackagingBoxHistoryDTO get(Long id) {
        ChangePackagingBoxHistory entity = baseDao.selectById(id);
        return ConvertUtils.sourceToTarget(entity, ChangePackagingBoxHistoryDTO.class);
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public void save(ChangePackagingBoxHistoryDTO dto) {
        ChangePackagingBoxHistory entity = ConvertUtils.sourceToTarget(dto, ChangePackagingBoxHistory.class);
        baseSupport.setCommonField(entity);
        insert(entity);
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public void update(ChangePackagingBoxHistoryDTO dto) {
        ChangePackagingBoxHistory entity = ConvertUtils.sourceToTarget(dto, ChangePackagingBoxHistory.class);
        baseSupport.setUpdateCommonField(entity);
        updateById(entity);
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public void delete(Long[] ids) {
        //删除
        deleteBatchIds(Arrays.asList(ids));
    }

}